searchNodes=[{"doc":"Calculate distance, bearing and more between Latitude/Longitude points.","ref":"Geocalc.html","title":"Geocalc","type":"module"},{"doc":"Calculates how far the point is along a path from from start-point, heading towards end-point. That is, if a perpendicular is drawn from the point to the (great circle) path, the along-track distance is the distance from the start point to where the perpendicular crosses the path. Examples iex&gt; berlin = [ 52.5075419 , 13.4251364 ] iex&gt; london = [ 51.5286416 , - 0.1015987 ] iex&gt; paris = [ 48.8588589 , 2.3475569 ] iex&gt; Geocalc . along_track_distance_to ( berlin , london , paris ) 310412.6031976226","ref":"Geocalc.html#along_track_distance_to/3","title":"Geocalc.along_track_distance_to/3","type":"function"},{"doc":"Calculate the given area surface. Returns area surface in square meters. Examples iex&gt; area = % Geocalc.Shape.Circle { latitude : 48.856614 , longitude : 2.3522219 , radius : 1000 } iex&gt; Geocalc . area_size ( area ) 3141592.653589793","ref":"Geocalc.html#area_size/1","title":"Geocalc.area_size/1","type":"function"},{"doc":"Check if a point is at the border of area . Returns true if at border, false if not. Examples iex&gt; area = % Geocalc.Shape.Circle { latitude : 48.856614 , longitude : 2.3522219 , radius : 1000 } iex&gt; point = %{ lat : 48.856418 , lng : 2.365871 } iex&gt; Geocalc . at_area_border? ( area , point ) true","ref":"Geocalc.html#at_area_border?/2","title":"Geocalc.at_area_border?/2","type":"function"},{"doc":"Check if a point at the center point of area . Returns true if at center point, false if not Examples iex&gt; area = % Geocalc.Shape.Circle { latitude : 48.856614 , longitude : 2.3522219 , radius : 100 } iex&gt; point = %{ lat : 48.856614 , lng : 2.3522219 } iex&gt; Geocalc . at_center_point? ( area , point ) true","ref":"Geocalc.html#at_center_point?/2","title":"Geocalc.at_center_point?/2","type":"function"},{"doc":"Calculates bearing. Returns radians. Examples iex&gt; berlin = { 52.5075419 , 13.4251364 } iex&gt; paris = { 48.8588589 , 2.3475569 } iex&gt; Geocalc . bearing ( berlin , paris ) - 1.9739245359361486 iex&gt; Geocalc . bearing ( paris , berlin ) 1.0178267866082613 iex&gt; berlin = %{ lat : 52.5075419 , lon : 13.4251364 } iex&gt; paris = %{ latitude : 48.8588589 , longitude : 2.3475569 } iex&gt; Geocalc . bearing ( berlin , paris ) - 1.9739245359361486","ref":"Geocalc.html#bearing/2","title":"Geocalc.bearing/2","type":"function"},{"doc":"Calculates a bounding box around a point with a radius in meters. Returns an array with 2 points (list format). The bottom left (southwest) point, and the top-right (northeast) one. Examples iex&gt; berlin = [ 52.5075419 , 13.4251364 ] iex&gt; radius = 10_000 iex&gt; Geocalc . bounding_box ( berlin , radius ) [ [ 52.417520954378574 , 13.277235453275123 ] , [ 52.59756284562143 , 13.573037346724874 ] ]","ref":"Geocalc.html#bounding_box/2","title":"Geocalc.bounding_box/2","type":"function"},{"doc":"Calculates a bounding box for a list of points. Returns an array with 2 points (list format). The bottom left (southwest) point, and the top-right (northeast) one. Examples iex&gt; berlin = [ 52.5075419 , 13.4251364 ] iex&gt; london = [ 51.5286416 , - 0.1015987 ] iex&gt; paris = [ 48.8588589 , 2.3475569 ] iex&gt; Geocalc . bounding_box_for_points ( [ berlin , london , paris ] ) [ [ 48.8588589 , - 0.1015987 ] , [ 52.5075419 , 13.4251364 ] ]","ref":"Geocalc.html#bounding_box_for_points/1","title":"Geocalc.bounding_box_for_points/1","type":"function"},{"doc":"Returns true if the bounding box contains the given point. Examples iex&gt; germany = [ [ 47.27 , 5.87 ] , [ 55.1 , 15.04 ] ] iex&gt; berlin = [ 52.5075419 , 13.4251364 ] iex&gt; Geocalc . contains_point? ( germany , berlin ) true","ref":"Geocalc.html#contains_point?/2","title":"Geocalc.contains_point?/2","type":"function"},{"doc":"Compute distance from the point to great circle defined by start-point and end-point. Returns distance in meters. Examples iex&gt; berlin = [ 52.5075419 , 13.4251364 ] iex&gt; london = [ 51.5286416 , - 0.1015987 ] iex&gt; paris = [ 48.8588589 , 2.3475569 ] iex&gt; Geocalc . cross_track_distance_to ( berlin , london , paris ) - 877680.2992295175","ref":"Geocalc.html#cross_track_distance_to/3","title":"Geocalc.cross_track_distance_to/3","type":"function"},{"doc":"Calculates the pair of meridians at which a great circle defined by two points crosses the given latitude. Returns longitudes. Examples iex&gt; berlin = [ 52.5075419 , 13.4251364 ] iex&gt; paris = [ 48.8588589 , 2.3475569 ] iex&gt; Geocalc . crossing_parallels ( berlin , paris , 12.3456 ) { :ok , 123.179463369946 , - 39.81144878508576 } iex&gt; point_1 = %{ lat : 0 , lng : 0 } iex&gt; point_2 = %{ lat : - 180 , lng : - 90 } iex&gt; latitude = 45.0 iex&gt; Geocalc . crossing_parallels ( point_1 , point_2 , latitude ) { :error , &quot;Not found&quot; }","ref":"Geocalc.html#crossing_parallels/3","title":"Geocalc.crossing_parallels/3","type":"function"},{"doc":"Converts degrees to radians. Returns radians. Examples iex&gt; Geocalc . degrees_to_radians ( 143.67156782221554 ) 2.5075419 iex&gt; Geocalc . degrees_to_radians ( - 10.735322818996854 ) - 0.18736672945597435","ref":"Geocalc.html#degrees_to_radians/1","title":"Geocalc.degrees_to_radians/1","type":"function"},{"doc":"Finds point between start and end points in direction to end point with given distance (in meters). Finds point from start point with given distance (in meters) and bearing. Returns array with latitude and longitude. Examples Find destination point by bearing: iex&gt; berlin = [ 52.5075419 , 13.4251364 ] iex&gt; paris = [ 48.8588589 , 2.3475569 ] iex&gt; bearing = Geocalc . bearing ( berlin , paris ) iex&gt; distance = 400_000 iex&gt; Geocalc . destination_point ( berlin , bearing , distance ) { :ok , [ 50.97658022467569 , 8.165929595956982 ] } iex&gt; zero_point = { 0.0 , 0.0 } iex&gt; equator_degrees = 90.0 iex&gt; equator_bearing = Geocalc . degrees_to_radians ( equator_degrees ) iex&gt; distance = 1_000_000 iex&gt; Geocalc . destination_point ( zero_point , equator_bearing , distance ) { :ok , [ 5.484172965344896e-16 , 8.993216059187306 ] } iex&gt; berlin = %{ lat : 52.5075419 , lon : 13.4251364 } iex&gt; bearing = - 1.9739245359361486 iex&gt; distance = 100_000 iex&gt; Geocalc . destination_point ( berlin , bearing , distance ) { :ok , [ 52.147030316318904 , 12.076990111001148 ] } Find destination point by point: iex&gt; berlin = [ 52.5075419 , 13.4251364 ] iex&gt; paris = [ 48.8588589 , 2.3475569 ] iex&gt; distance = 250_000 iex&gt; Geocalc . destination_point ( berlin , paris , distance ) { :ok , [ 51.578054644172525 , 10.096282782248409 ] }","ref":"Geocalc.html#destination_point/3","title":"Geocalc.destination_point/3","type":"function"},{"doc":"Calculates distance between 2 points. Returns distance in meters. Examples iex&gt; berlin = [ Decimal . new ( &quot;52.5075419&quot; ) , Decimal . new ( &quot;13.4251364&quot; ) ] iex&gt; paris = [ 48.8588589 , 2.3475569 ] iex&gt; Geocalc . distance_between ( berlin , paris ) 878327.4291149472 iex&gt; Geocalc . distance_between ( paris , berlin ) 878327.4291149472 iex&gt; berlin = %{ lat : 52.5075419 , lon : 13.4251364 } iex&gt; london = %{ lat : Decimal . new ( &quot;51.5286416&quot; ) , lng : Decimal . new ( &quot;-0.1015987&quot; ) } iex&gt; paris = %{ latitude : 48.8588589 , longitude : 2.3475569 } iex&gt; Geocalc . distance_between ( berlin , paris ) 878327.4291149472 iex&gt; Geocalc . distance_between ( paris , london ) 344229.88946533133","ref":"Geocalc.html#distance_between/2","title":"Geocalc.distance_between/2","type":"function"},{"doc":"Extend the bounds to contain the given bounds. Returns an array with 2 points (list format). The bottom left (southwest) point, and the top-right (northeast) one. Examples iex&gt; berlin = [ 52.5075419 , 13.4251364 ] iex&gt; london = [ 51.5286416 , - 0.1015987 ] iex&gt; Geocalc . extend_bounding_box ( [ berlin , berlin ] , [ london , london ] ) [ [ 51.5286416 , - 0.1015987 ] , [ 52.5075419 , 13.4251364 ] ]","ref":"Geocalc.html#extend_bounding_box/2","title":"Geocalc.extend_bounding_box/2","type":"function"},{"doc":"Compute the geographic center (aka geographic midpoint, center of gravity) for an array of geocoded objects and/or [lat,lon] arrays (can be mixed). Any objects missing coordinates are ignored. Follows the procedure documented at http://www.geomidpoint.com/calculation.html . Examples iex&gt; point_1 = [ 0 , 0 ] iex&gt; point_2 = [ 0 , 3 ] iex&gt; Geocalc . geographic_center ( [ point_1 , point_2 ] ) [ 0.0 , 1.5 ]","ref":"Geocalc.html#geographic_center/1","title":"Geocalc.geographic_center/1","type":"function"},{"doc":"Check if a point is inside area . Returns true if inside area, false if not. Examples iex&gt; area = % Geocalc.Shape.Circle { latitude : 48.856614 , longitude : 2.3522219 , radius : 1000 } iex&gt; point = %{ lat : 48.856612 , lng : 2.3522217 } iex&gt; Geocalc . in_area? ( area , point ) true","ref":"Geocalc.html#in_area?/2","title":"Geocalc.in_area?/2","type":"function"},{"doc":"Finds intersection point from start points with given bearings. Returns array with latitude and longitude. Raise an exception if no intersection point found. Examples Find intersection point by bearing: iex&gt; berlin = [ 52.5075419 , 13.4251364 ] iex&gt; berlin_bearing = - 2.102 iex&gt; london = [ 51.5286416 , - 0.1015987 ] iex&gt; london_bearing = 1.502 iex&gt; Geocalc . intersection_point ( berlin , berlin_bearing , london , london_bearing ) { :ok , [ 51.49271112601574 , 10.735322818996854 ] } iex&gt; berlin = %{ lat : 52.5075419 , lng : 13.4251364 } iex&gt; bearing = Geocalc . degrees_to_radians ( 90.0 ) iex&gt; Geocalc . intersection_point ( berlin , bearing , berlin , bearing ) { :ok , [ 52.5075419 , 13.4251364 ] } Find intersection point by point: iex&gt; berlin = { 52.5075419 , 13.4251364 } iex&gt; london = { 51.5286416 , - 0.1015987 } iex&gt; paris = { 48.8588589 , 2.3475569 } iex&gt; Geocalc . intersection_point ( berlin , london , paris , london ) { :ok , [ 51.5286416 , - 0.10159869999998701 ] } Raise exception when no intersection points: iex&gt; berlin_1 = %{ lat : 52.5075419 , lng : 13.4251364 } iex&gt; berlin_2 = %{ lat : 52.5075419 , lng : 13.57 } iex&gt; bearing = Geocalc . degrees_to_radians ( 90.0 ) iex&gt; Geocalc . intersection_point ( berlin_1 , bearing , berlin_2 , bearing ) { :error , &quot;No intersection point found&quot; }","ref":"Geocalc.html#intersection_point/4","title":"Geocalc.intersection_point/4","type":"function"},{"doc":"Returns true if the bounding box intersects the given bounds. Two bounds intersect if they have at least one point in common. Examples iex&gt; germany = [ [ 47.27 , 5.87 ] , [ 55.1 , 15.04 ] ] iex&gt; poland = [ [ 49.0 , 14.12 ] , [ 55.03 , 24.15 ] ] iex&gt; Geocalc . intersects_bounding_box? ( germany , poland ) true","ref":"Geocalc.html#intersects_bounding_box?/2","title":"Geocalc.intersects_bounding_box?/2","type":"function"},{"doc":"Calculates maximum latitude reached when travelling on a great circle on given bearing from the point (Clairaut's formula). Negate the result for the minimum latitude (in the Southern hemisphere). The maximum latitude is independent of longitude; it will be the same for all points on a given latitude. Returns radians. Examples iex&gt; berlin = [ 52.5075419 , 13.4251364 ] iex&gt; paris = [ 48.8588589 , 2.3475569 ] iex&gt; bearing = Geocalc . bearing ( berlin , paris ) iex&gt; Geocalc . max_latitude ( berlin , bearing ) 55.953467429882835","ref":"Geocalc.html#max_latitude/2","title":"Geocalc.max_latitude/2","type":"function"},{"doc":"Check if a point is outside area . Returns true if outside area, false if not Examples iex&gt; area = % Geocalc.Shape.Circle { latitude : 48.856614 , longitude : 2.3522219 , radius : 10 } iex&gt; point = %{ lat : 48.856418 , lng : 2.365871 } iex&gt; Geocalc . outside_area? ( area , point ) true","ref":"Geocalc.html#outside_area?/2","title":"Geocalc.outside_area?/2","type":"function"},{"doc":"Returns true if the bounding box overlaps the given bounds. Two bounds overlap if their intersection is an area. Examples iex&gt; germany = [ [ 47.27 , 5.87 ] , [ 55.1 , 15.04 ] ] iex&gt; berlin_suburbs = [ [ 52.338261 , 13.08835 ] , [ 52.67551 , 13.76116 ] ] iex&gt; Geocalc . overlaps_bounding_box? ( germany , berlin_suburbs ) true","ref":"Geocalc.html#overlaps_bounding_box?/2","title":"Geocalc.overlaps_bounding_box?/2","type":"function"},{"doc":"Converts radians to degrees. Returns degrees. Examples iex&gt; Geocalc . radians_to_degrees ( 2.5075419 ) 143.67156782221554 iex&gt; Geocalc . radians_to_degrees ( - 0.1015987 ) - 5.821176714015797","ref":"Geocalc.html#radians_to_degrees/1","title":"Geocalc.radians_to_degrees/1","type":"function"},{"doc":"Calculates if a point is within a polygon. Returns boolean. Examples iex&gt; point = [ 14.952242 , 60.1696017 ] iex&gt; poly = [ [ 24.950899 , 60.169158 ] , [ 24.953492 , 60.169158 ] , [ 24.953510 , 60.170104 ] , [ 24.950958 , 60.169990 ] ] iex&gt; Geocalc . within? ( poly , point ) false iex&gt; point = [ 24.952242 , 60.1696017 ] iex&gt; poly = [ [ 24.950899 , 60.169158 ] , [ 24.953492 , 60.169158 ] , [ 24.953510 , 60.170104 ] , [ 24.950958 , 60.169990 ] ] iex&gt; Geocalc . within? ( poly , point ) true iex&gt; point = [ 24.976567 , 60.1612500 ] iex&gt; poly = [ [ 24.950899 , 60.169158 ] , [ 24.953492 , 60.169158 ] , [ 24.953510 , 60.170104 ] , [ 24.950958 , 60.169990 ] ] iex&gt; Geocalc . within? ( poly , point ) false","ref":"Geocalc.html#within?/2","title":"Geocalc.within?/2","type":"function"},{"doc":"Calculates if a point is within radius of the center of a circle. Returns boolean. Examples iex&gt; berlin = [ 52.5075419 , 13.4251364 ] iex&gt; paris = [ 48.8588589 , 2.3475569 ] iex&gt; Geocalc . within? ( 10 , paris , berlin ) false iex&gt; Geocalc . within? ( 10 , berlin , paris ) false iex&gt; san_juan = %{ lat : 18.4655 , lon : 66.1057 } iex&gt; puerto_rico = %{ lat : 18.2208 , lng : 66.5901 } iex&gt; Geocalc . within? ( 170_000 , puerto_rico , san_juan ) true","ref":"Geocalc.html#within?/3","title":"Geocalc.within?/3","type":"function"},{"doc":"","ref":"Geocalc.html#t:point_or_bearing/0","title":"Geocalc.point_or_bearing/0","type":"type"},{"doc":"The Geocalc.DMS is a struct which contains degrees, minutes, seconds and cardinal direction. Also have functions to convert DMS to decimal degrees.","ref":"Geocalc.DMS.html","title":"Geocalc.DMS","type":"module"},{"doc":"","ref":"Geocalc.DMS.html#to_decimal/1","title":"Geocalc.DMS.to_decimal/1","type":"function"},{"doc":"Converts Geocalc.DMS to decimal degrees. Examples iex&gt; dms = % Geocalc.DMS { hours : 13 , minutes : 31 , seconds : 59.998 , direction : &quot;N&quot; } iex&gt; Geocalc.DMS . to_degrees ( dms ) 13.533332777777778","ref":"Geocalc.DMS.html#to_degrees/1","title":"Geocalc.DMS.to_degrees/1","type":"function"},{"doc":"","ref":"Geocalc.DMS.html#t:t/0","title":"Geocalc.DMS.t/0","type":"type"},{"doc":"The Geocalc.Point protocol is responsible for receiving latitude and longitude from any Elixir data structure. At this time it have implementations only for Map, Tuple and List, and Shape defined inside this project. Point values can be decimal degrees or DMS (degrees, minutes, seconds).","ref":"Geocalc.Point.html","title":"Geocalc.Point","type":"protocol"},{"doc":"Returns point latitude.","ref":"Geocalc.Point.html#latitude/1","title":"Geocalc.Point.latitude/1","type":"function"},{"doc":"Returns point longitude.","ref":"Geocalc.Point.html#longitude/1","title":"Geocalc.Point.longitude/1","type":"function"},{"doc":"","ref":"Geocalc.Point.html#t:t/0","title":"Geocalc.Point.t/0","type":"type"},{"doc":"Geocalc.Shape contains Circle , Rectangle and Ellipse shapes. Those shapes define a geographical area projection and are designed to be used for geofencing, ie: the user can determine if one point is inside or outside a geographical zone. Geographical zones are defined with a center point and several spatial dimensions (see each shape documentation).","ref":"Geocalc.Shape.html","title":"Geocalc.Shape","type":"module"},{"doc":"Circle describes a circular geographical area, centered on latitude , longitude , with a radius in meters. latitude and longitude could be Decimal degrees or Geocalc.DMS .","ref":"Geocalc.Shape.Circle.html","title":"Geocalc.Shape.Circle","type":"module"},{"doc":"","ref":"Geocalc.Shape.Circle.html#t:t/0","title":"Geocalc.Shape.Circle.t/0","type":"type"},{"doc":"Ellipse describes an elliptic geographical area, centered on latitude , longitude (could be Decimal degrees or Geocalc.DMS ), with long_semi_axis and short_semi_axis (both in meters) and an azimuth angle (in degrees). long_semi_axis is the length of the longest diameter, also called semi-major axis. short_semi_axis is the length of the shortest diameter, also called semi-minor axis. angle is the azimuth angle of the long semi-axis.","ref":"Geocalc.Shape.Ellipse.html","title":"Geocalc.Shape.Ellipse","type":"module"},{"doc":"","ref":"Geocalc.Shape.Ellipse.html#t:t/0","title":"Geocalc.Shape.Ellipse.t/0","type":"type"},{"doc":"Rectangle describes a rectangular geographical area, centered on latitude , longitude (could be Decimal degrees or Geocalc.DMS ), with long_semi_axis and short_semi_axis (both in meters) and an azimuth angle (in degrees). long_semi_axis is the distance between the center point and the short side of the rectangle. short_semi_axis is the distance between the center point and the long side of the rectangle. angle is the azimuth angle of the long side of the rectangle, ie: the angle between north and long_semi_axis .","ref":"Geocalc.Shape.Rectangle.html","title":"Geocalc.Shape.Rectangle","type":"module"},{"doc":"","ref":"Geocalc.Shape.Rectangle.html#t:t/0","title":"Geocalc.Shape.Rectangle.t/0","type":"type"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Add support for elixir 1.12, 1.13, 1.14 and otp 24, 25 Drop support for elixir 1.6, 1.7, 1.8 and otp 19 Faster geographic center calculation Accept Decimal as Geocalc.Point Mark Geocalc.DMS.to_decimal/1 as deprecated","ref":"changelog.html#v0-8-5-2022-10-14","title":"Changelog - v0.8.5 - 2022-10-14","type":"extras"},{"doc":"Change area_size return typespec Add geofencing capabilities Add benchmark for within? and bounding_box Add Elixir 1.11 to build matrix","ref":"changelog.html#v0-8-4-2021-03-31","title":"Changelog - v0.8.4 - 2021-03-31","type":"extras"},{"doc":"Add dialyxir checks to Travis build configuration Add along track distance to point Fix dialyzer warning on Geocalc.crossing_parallels/3","ref":"changelog.html#v0-8-3-2020-10-03","title":"Changelog - v0.8.3 - 2020-10-03","type":"extras"},{"doc":"Fix docs formatting Fix in intersection point formula Add Erlang/OTP 23.1 to build matrix Update dependencies","ref":"changelog.html#v0-8-2-2020-10-03","title":"Changelog - v0.8.2 - 2020-10-03","type":"extras"},{"doc":"Update Erlang/OTP 22.3 on build matrix Add Elixir 1.10 to build matrix Add type Geocalc.DMS.t() Add Erlang/OTP 22.1 to build matrix","ref":"changelog.html#v0-8-1-2020-06-12","title":"Changelog - v0.8.1 - 2020-06-12","type":"extras"},{"doc":"Update documentation for DMS Point implementation with DMS values Add DMS to decimal convertor Update dependencies Add Elixir 1.8 and 1.9 to build matrix Fix doc on radius is first parameter for within?/3 Add Erlang/OTP 21.2 to Travis build matrix","ref":"changelog.html#v0-8-0-2019-10-20","title":"Changelog - v0.8.0 - 2019-10-20","type":"extras"},{"doc":"Fix Travis CI issues Remove IO calls Add point in polygon","ref":"changelog.html#v0-7-2-2018-12-23","title":"Changelog - v0.7.2 - 2018-12-23","type":"extras"},{"doc":"Add more calculations with bounding box","ref":"changelog.html#v0-7-1-2018-10-22","title":"Changelog - v0.7.1 - 2018-10-22","type":"extras"},{"doc":"Add bounding box for a list of points Add Credo to Travis build Format files with Elixir code formatter Drop support for elixir 1.5 Update dependencies Add Elixir 1.7 to build matrix Add Erlang/OTP 16.6 to build matrix","ref":"changelog.html#v0-7-0-2018-10-16","title":"Changelog - v0.7.0 - 2018-10-16","type":"extras"},{"doc":"Add within radius check Remove unused var warning","ref":"changelog.html#v0-6-1-2018-03-29","title":"Changelog - v0.6.1 - 2018-03-29","type":"extras"},{"doc":"Do not use GenServer","ref":"changelog.html#v0-6-0-2017-10-28","title":"Changelog - v0.6.0 - 2017-10-28","type":"extras"},{"doc":"Add cross track distance to point Update dependencies Add Erlang/OTP 20.1 to build matrix","ref":"changelog.html#v0-5-6-2017-10-21","title":"Changelog - v0.5.6 - 2017-10-21","type":"extras"},{"doc":"Add Elixir 1.5.0 to build matrix","ref":"changelog.html#v0-5-5-2017-07-28","title":"Changelog - v0.5.5 - 2017-07-28","type":"extras"},{"doc":"Add Elixir 1.4.2 to build matrix Update deps Fix ambiguity warnings Add Erlang/OTP 19.1 and update elixir 1.3 in Travis build matrix","ref":"changelog.html#v0-5-4-2017-02-20","title":"Changelog - v0.5.4 - 2017-02-20","type":"extras"},{"doc":"Don't prevent intersection point from original crash","ref":"changelog.html#v0-5-3-2016-10-30","title":"Changelog - v0.5.3 - 2016-10-30","type":"extras"},{"doc":"Fix docs for intersection point Add geographic center calculations","ref":"changelog.html#v0-5-2-2016-10-24","title":"Changelog - v0.5.2 - 2016-10-24","type":"extras"},{"doc":"Add bounding_box calculation Clarify readme that distances are in meters","ref":"changelog.html#v0-5-1-2016-09-14","title":"Changelog - v0.5.1 - 2016-09-14","type":"extras"},{"doc":"Check Elixir 1.2/1.3 on Travis build matrix Support for Elixir 1.3 Make geocalc an OTP app Add benchmrks for geocalc Add Erlang/OTP 18.2 to Travis builds matrix","ref":"changelog.html#v0-5-0-2016-07-18","title":"Changelog - v0.5.0 - 2016-07-18","type":"extras"},{"doc":"Fix intersection point for the lines parallel to elevator Cleanup tests Speed up Travis builds","ref":"changelog.html#v0-4-0-2015-12-10","title":"Changelog - v0.4.0 - 2015-12-10","type":"extras"},{"doc":"Replace IntersectionNotFoundError with throw/catch Check point implementations for numbers Fix version badge","ref":"changelog.html#v0-3-0-2015-10-29","title":"Changelog - v0.3.0 - 2015-10-29","type":"extras"},{"doc":"Add version badge Merge pull request #8 from yltsrc/point-for-tuple Point implementation for Tuple","ref":"changelog.html#v0-2-1-2015-10-19","title":"Changelog - v0.2.1 - 2015-10-19","type":"extras"},{"doc":"Add typespecs Update README","ref":"changelog.html#v0-2-0-2015-10-18","title":"Changelog - v0.2.0 - 2015-10-18","type":"extras"},{"doc":"Update destination/intersection point api to handle error cases Update docs","ref":"changelog.html#v0-1-1-2015-10-16","title":"Changelog - v0.1.1 - 2015-10-16","type":"extras"},{"doc":"Add function to find intersection point Clenup api Update README","ref":"changelog.html#v0-1-0-2015-10-08","title":"Changelog - v0.1.0 - 2015-10-08","type":"extras"},{"doc":"Add function to find point between 2 points with distance README cleanup Add build status badge Setup Travis CI Cleanup dependencies Add function to calculate bearing between 2 points","ref":"changelog.html#v0-0-4-2015-10-06","title":"Changelog - v0.0.4 - 2015-10-06","type":"extras"},{"doc":"Generate docs Add info about hex package Add function to calculate distance between 2 points","ref":"changelog.html#v0-0-3-2015-10-06","title":"Changelog - v0.0.3 - 2015-10-06","type":"extras"},{"doc":"Initial commit","ref":"changelog.html#v0-0-2-2015-10-06","title":"Changelog - v0.0.2 - 2015-10-06","type":"extras"},{"doc":"The MIT License (MIT) Copyright (c) 2015 Yura Tolstik Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"Calculate distance, bearing and more between latitude/longitude points. All the formulas are adapted from http://www.movable-type.co.uk/scripts/latlong.html . Area calculations are implemented from ETSI EN 302 931 v1.1.1 standard.","ref":"readme.html","title":"Geocalc","type":"extras"},{"doc":"First, add :geocalc to your mix.exs dependencies: def deps do [ { :geocalc , &quot;~&gt; 0.8&quot; } ] end And then fetch your dependencies: $ mix deps.get","ref":"readme.html#installation","title":"Geocalc - Installation","type":"extras"},{"doc":"Calculate distance (in meters) between 2 points Geocalc . distance_between ( [ 50.0663889 , - 5.7147222 ] , [ 58.6438889 , - 3.07 ] ) # =&gt; 968853.5464535094 Calculate if point is inside a circle given by a center point and a radius (in meters) san_juan = [ 18.4655 , 66.1057 ] puerto_rico = [ 18.2208 , 66.5901 ] Geocalc . within? ( 170_000 , san_juan , puerto_rico ) # =&gt; true Get destination point given distance (meters) from start and end point Geocalc . destination_point ( [ 50.0663889 , - 5.7147222 ] , [ 58.6438889 , - 3.07 ] , 100_000 ) # =&gt; {:ok, [50.95412546615634, -5.488452905258299]} Get destination point given distance (meters) and bearing from start point Geocalc . destination_point ( [ 50.0663889 , - 5.7147222 ] , 2.123 , 100_000 ) # =&gt; {:ok, [49.58859917965055, -4.533613856982982]} Calculate bearing from start and end points Geocalc . bearing ( [ 50.0663889 , - 5.7147222 ] , [ 58.6438889 , - 3.07 ] ) # =&gt; 0.1591708517503001 Get intersection point given start points and bearings Geocalc . intersection_point ( [ 50.0663889 , - 5.7147222 ] , 2.123 , [ 55.0663889 , - 15.7147222 ] , 2.123 ) # =&gt; {:ok, [48.04228582473962, -1.0347033632388496]} Geocalc . intersection_point ( [ 50.0663889 , - 5.7147222 ] , 2.123 , [ 50.0663889 , - 5.7147222 ] , 2.123 ) # =&gt; {:error, &quot;No intersection point found&quot;} Get bounding box from a point and radius berlin = [ 52.5075419 , 13.4251364 ] radius = 10_000 Geocalc . bounding_box ( berlin , radius ) # =&gt; [[52.417520954378574, 13.277235453275123], [52.59756284562143, 13.573037346724874]] Get bounding box from a list of points berlin = [ 52.5075419 , 13.4251364 ] rome = [ 41.9102415 , 12.3959161 ] minsk = [ 53.8838884 , 27.5949741 ] Geocalc . bounding_box_for_points ( [ berlin , rome , minsk ] ) # =&gt; [[41.9102415, 12.3959161], [53.8838884, 27.5949741]] Get geographical center point berlin = [ 52.5075419 , 13.4251364 ] london = [ 51.5286416 , - 0.1015987 ] rome = [ 41.9102415 , 12.3959161 ] Geocalc . geographic_center ( [ berlin , london , rome ] ) # =&gt; [48.810406537400254, 8.785092188535195] Get maximum latitude reached when travelling on a great circle on given bearing from the point berlin = [ 52.5075419 , 13.4251364 ] paris = [ 48.8588589 , 2.3475569 ] bearing = Geocalc . bearing ( berlin , paris ) Geocalc . max_latitude ( berlin , bearing ) # =&gt; 55.953467429882835 Get distance from the point to great circle defined by start-point and end-point berlin = [ 52.5075419 , 13.4251364 ] london = [ 51.5286416 , - 0.1015987 ] paris = [ 48.8588589 , 2.3475569 ] Geocalc . cross_track_distance_to ( berlin , london , paris ) # =&gt; -877680.2992295175 Calculate how far the point is along a path from from start-point, heading towards end-point berlin = [ 52.5075419 , 13.4251364 ] london = [ 51.5286416 , - 0.1015987 ] paris = [ 48.8588589 , 2.3475569 ] Geocalc . along_track_distance_to ( berlin , london , paris ) # =&gt; 310412.6031976226 Get the pair of meridians at which a great circle defined by two points crosses the given latitude berlin = [ 52.5075419 , 13.4251364 ] paris = [ 48.8588589 , 2.3475569 ] Geocalc . crossing_parallels ( berlin , paris , 12.3456 ) # =&gt; {:ok, 123.179463369946, -39.81144878508576} Convert degrees to radians Geocalc . degrees_to_radians ( 245 ) # =&gt; -2.007128639793479 Convert radians to degrees Geocalc . radians_to_degrees ( 1.234 ) # =&gt; 70.70299191914359","ref":"readme.html#usage","title":"Geocalc - Usage","type":"extras"},{"doc":"Contains geometrical shapes designed for geofencing calculations, ie: determine if one point is inside or outside a geographical area. Three area shapes are defined: Circle Rectangle Ellipse Check if a point is inside an area area = % Geocalc.Shape.Circle { latitude : 48.856614 , longitude : 2.3522219 , radius : 1000 } point = %{ lat : 48.856612 , lng : 2.3522217 } Geocalc . in_area? ( area , point ) # =&gt; true Check if a point is outside an area area = % Geocalc.Shape.Circle { latitude : 48.856614 , longitude : 2.3522219 , radius : 10 } point = %{ lat : 48.856418 , lng : 2.365871 } Geocalc . outside_area? ( area , point ) # =&gt; true Check if a point is at the border of an area area = % Geocalc.Shape.Circle { latitude : 48.856614 , longitude : 2.3522219 , radius : 1000 } point = %{ lat : 48.856418 , lng : 2.365871 } Geocalc . at_area_border? ( area , point ) # =&gt; true Check if a point at the center point of an area area = % Geocalc.Shape.Circle { latitude : 48.856614 , longitude : 2.3522219 , radius : 100 } point = %{ lat : 48.856614 , lng : 2.3522219 } Geocalc . at_center_point? ( area , point ) # =&gt; true","ref":"readme.html#geocalc-shape","title":"Geocalc - Geocalc.Shape","type":"extras"},{"doc":"Everything which implements Geocalc.Point protocol can be passed as a point argument for any function in this library. We already have implementations for List , Tuple and Map . You can define your own implementations if you need, everything we need to know to do calculations are latitude and longitude .","ref":"readme.html#geocalc-point-protocol","title":"Geocalc - Geocalc.Point protocol","type":"extras"},{"doc":"Geocalc.DMS is a struct which contains degrees, minutes and seconds, which also can be used in Geocalc.Point . Additionally now there is an options to convert Geocalc.DMS to decimal degrees. dms = % Geocalc.DMS { hours : 13 , minutes : 31 , seconds : 59.998 , direction : &quot;N&quot; } Geocalc.DMS . to_degrees ( dms ) # =&gt; 13.533332777777778","ref":"readme.html#geocalc-dms","title":"Geocalc - Geocalc.DMS","type":"extras"},{"doc":"Run this command to generate the benchmark result: $ MIX_ENV=bench mix bench Settings: duration: 1.0 s ## GeocalcBench [03:00:36] 1/10: bearing [03:00:37] 2/10: bounding box [03:00:39] 3/10: bounding box for points [03:00:53] 3/10: degrees to radians [03:01:03] 5/10: destination point [03:01:06] 6/10: distance between [03:01:08] 7/10: intersection point [03:01:11] 8/10: radians to degrees [03:01:13] 9/10: within?/2 [03:01:15] 10/10: within?/3 Finished in 31.32 seconds ## GeocalcBench benchmark name iterations average time degrees to radians 100000000 0.09 µs/op radians to degrees 10000000 0.17 µs/op bounding box 1000000 1.51 µs/op bearing 1000000 1.65 µs/op destination point 1000000 1.89 µs/op within?/3 1000000 2.10 µs/op distance between 1000000 2.33 µs/op intersection point 500000 4.96 µs/op bounding box for points 500000 7.26 µs/op within?/2 100000 12.17 µs/op","ref":"readme.html#benchmark","title":"Geocalc - Benchmark","type":"extras"},{"doc":"Copyright (c) 2015 Yura Tolstik Released under the MIT License, which can be found in the repository in LICENSE.md .","ref":"readme.html#copyright-and-license","title":"Geocalc - Copyright and License","type":"extras"}]